Monkey(1)

NAME
monkey - Monkey HTTP Server

SYNOPSIS
monkey [options]

DESCRIPTION
monkey is fast and scalable web server for Linux, OSX and FreeBSD. This manual page only lists the command line arguments available. For further and more detailed information regarding the program configuration see the Monkey manual, found at http://monkey-project.com/documentation .

OPTIONS
This command will launch the Monkey webserver. It accepts the following options:

-c, --configdir=DIR
    Allows to specify an optional configuration directory where the required configuration files by Monkey are located. It's expected that under this directory exists the files: monkey.conf, monkey.mime, plugins.load and the plugins/ directory.

-s, --serverconf=FILE
    Overrides the default path of the 'monkey.conf' configuration file.

-d, --daemon
    Launches the server as a daemon (background process). The default behaviour is to stay attached to the controlling terminal.

-I, --pid-file=FILE
    Overrides the default path for the 'pid' file.

-p, --port=PORT
    Specify a single listener TCP port, this option overrides the content of the configuration file.

-o, --one-shot=DIR
    The one-shot mode and directory path associated, makes to serve that directory content as the document root of the default virtual host.

-t, --transport=TRANSPORT
    Specify a transport layer plugin. This option overrides the configuration file and allows just one plugin, either 'liana' for plain sockets or 'tls' for SSL/TLS support (just if 'tls' plugin was compiled and available).

-w, --workers=N
    Specify the number of worker threads that Monkey will spawn upon start. Each worker thread is capable to handle several connections, is suggested to spawn a worker per CPU core available. By default Monkey set this value to zero (--workers=0) which let's Monkey core to detect the number of CPU core available and spawn one worker per core.

-m, --mimes-conf-file=FILE
    Specify a configuration file that holds the mime types available.

-l, --plugins-load-conf-file=FILE
    Specify a configuration file that holds the list of dynamic plugins to load.

-S, --sites-conf-dir=DIR
    Specify the directory path where the files that defines the virtual hosts are available.

-P, --plugins-conf-dir=DIR
    Specify the directory path where the plugins can locate their configuration files.

-b, --balancing-mode
    This option enable the OLD balancing mode when receiving connections. It means that for every TCP connection that arrives, the Monkey Scheduler will assign the connection to the least-busy worker thread. The default and new mechanism is based on the shared TCP sockets implementation, which let the OS Kernel to decide to which worker thread assign the new connection.

-T, --allow-shared-sockets
    When using shared TCP sockets (no --balancing-mode), multiple instances of Monkey can be started. Monkey will detect if the TCP port is in use by another process, despite the address can be shared, Monkey will notify this and abort. This option let Monkey know that despites the address is shared and in-use, continue anyways.

-b, --build
    Print build information and exit. It prints to the standard output the configure options, default paths, built-in plugins and others.

-v, --version
    Prints Monkey's version and exit.

-h, --help
    Prints this help.

SIGNALS
The following signals are supported by Monkey:

SIGTERM, Exits

SIGINT,  Exits

SIGHUP,  Exits

SIGBUS,  Print invalid address

SIGSEGV, Print invalid address

BUGS

  Bug reports
In general, send bug reports to the bug report mailing list at <monkey@lists.monkey-project.com>. You are requested to use a descriptive subject for your email message, perhaps parts of the error message.

AUTHOR
Eduardo Silva <eduardo@monkey.io> and the rest of the Monkey Project team.

This manpage is maintained by the Monkey HTTP Daemon Project team.